//=============================================================================
// Copyright  2008 Point Grey Research, Inc. All Rights Reserved.
//
// This software is the confidential and proprietary information of Point
// Grey Research, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with PGR.
//
// PGR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
// SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE, OR NON-INFRINGEMENT. PGR SHALL NOT BE LIABLE FOR ANY DAMAGES
// SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
// THIS SOFTWARE OR ITS DERIVATIVES.
//=============================================================================
//=============================================================================
// $Id: Program.cs,v 1.16 2009/09/08 23:56:40 soowei Exp $
//=============================================================================

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Emgu.CV.Structure;
using Emgu.CV;
using Emgu.CV.UI;
using FlyCapture2Managed;
using System.Windows.Forms;
using System.Drawing;
using FlyCapture2;

namespace TP
{
    class Grabber
    {
        ManagedBusManager busMgr;
        ManagedPGRGuid guid;
        ManagedCamera cam;
        CameraInfo camInfo;
        EmbeddedImageInfo embeddedInfo;
        uint numCameras;
        ManagedImage rawImage;
        ManagedImage convertedImage;


        public Grabber()
        {
            rawImage = new ManagedImage();
            convertedImage = new ManagedImage();

            cam = new ManagedCamera();

            busMgr = new ManagedBusManager();
            numCameras = busMgr.GetNumOfCameras();

            Console.WriteLine("Number of cameras detected: {0}", numCameras);
            
            for (uint i = 0; i < numCameras; i++)
            {
                guid = busMgr.GetCameraFromIndex(i);
            }
        }


        public Image<Bgr, Byte> RetourImageTest()
        {
            return new Image<Bgr, Byte>("Test.jpg");
        }

        public Image<Bgr, Byte> RetourImage()
        {
            cam.RetrieveBuffer(rawImage);
            rawImage.Convert(PixelFormat.PixelFormatBgr, convertedImage);
            System.Drawing.Bitmap Bitmap1 = (System.Drawing.Bitmap)convertedImage.bitmap;
            Image<Bgr, Byte> image = new Image<Bgr, byte>(Bitmap1);
            Bitmap1.Dispose();
            Bitmap1 = null;
            
            return image;
        }


         public bool partirCamera()
        {

            try
            {
                /// Connect to a camera
                cam.Connect(guid);

                // Get the camera information
                camInfo = cam.GetCameraInfo();

  
              
                // Get embedded image info from camera
                embeddedInfo = cam.GetEmbeddedImageInfo();

                CameraProperty prop;
                prop = cam.GetProperty(PropertyType.Gain);
                prop.onOff = true;
                prop.autoManualMode = false;
                prop.absControl = true;
                prop.absValue = 30;

                cam.SetProperty(prop);

                prop = cam.GetProperty(PropertyType.AutoExposure);
                prop.onOff = true;
                prop.autoManualMode = false;
                prop.absControl = true;
                prop.absValue = (float) (1.79);
                cam.SetProperty(prop);

                prop = cam.GetProperty(PropertyType.Shutter);
                prop.onOff = true;
                prop.autoManualMode = false;
                prop.absControl = true;
                prop.absValue = 7;



                cam.SetProperty(prop);


                // Enable timestamp collection	
                if (embeddedInfo.timestamp.available == true)
                {
                    embeddedInfo.timestamp.onOff = true;
                }

                // Set embedded image info to camera
                cam.SetEmbeddedImageInfo(embeddedInfo);


                // Start capturing images
                cam.StartCapture();
            }
            catch {
                MessageBox.Show("La camera n'est pas fonctionnelle");

                return false;
            }
            return true;
        
        }


         public void arreterCamera()
        {

            try
            {

                // Stop capturing images
                cam.StopCapture();

                // Disconnect the camera
                cam.Disconnect();
            }
            catch { }
        }

    }
}
